unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls,ChipThr, StdCtrls;

type
  TMainForm = class(TForm)
    Book: TPageControl;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    procedure BasTerminated(Sender:TObject);
    procedure InputKey(Sender:TObject; var Key: Char);
    procedure OutputKey(Sender:TObject; Key:Char);
  public
    mid:integer;
    procedure NewMachine;
  end;

var
  MainForm: TMainForm;

implementation
uses Console;

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
 NewMachine
end;

procedure TMainForm.BasTerminated;
var i:integer;
begin
 for i:=Book.PageCount-1 downto 0 do
  if Book.Pages[i].Tag=integer(Sender) then begin
   Book.Pages[i].Free;
   break
  end;
 if Book.PageCount=0 then Close
end;

procedure TMainForm.InputKey;
var bas:TBasicThread;
begin
 bas:=TBasicThread(TTabSheet(TMemo(Sender).Parent).Tag);
 bas.PushKey(Key);
 Key:=#0
end;

procedure TMainForm.OutputKey;
var view:TMemo;
var row,col:integer;

 procedure Put(Key:char);
 var line:string;
 begin
  while view.Lines.Count<=row do view.Lines.Add('');
  line:=view.Lines[row];
  while length(line)<=col do line:=line+' ';
  line[col+1]:=Key;
  inc(col);
  view.Lines[row]:=line;

  if col=80 { TUNE: } then begin
   col:=0;
   inc(row)
  end;
 end;

begin
 view:=TMemo(TBasicThread(Sender).Tag);
 view.Lines.BeginUpdate;
 try
  row:=LoWord(view.Tag);
  col:=HiWord(view.Tag);
  case Key of
  #13: col:=0;
  #10: row:=row+1;
  #7: MessageBeep(0);
  #8: if col>0 then begin dec(col);Put(' ');dec(col) end;
  else
   Put(Key)
  end;

  if row=50 then begin
   view.Lines.Delete(0);
   dec(row)
  end;
 finally
  view.Lines.EndUpdate
 end;

 view.Tag:=MakeLong(row,col)
end;

procedure TMainForm.NewMachine;
var sheet:TTabSheet;
var bas:TBasicThread;
var view:TMemo;
begin
 sheet:=TTabSheet.Create(Book);
 inc(mid);
 sheet.Caption:=IntToStr(mid);

 view:=TMemo.Create(sheet);
 view.Parent:=sheet;
 view.Align:=alClient;
 view.Font.Name:='Fixedsys';
 view.Color:=clBlack;
 view.Font.Color:=clLime;
 view.ReadOnly:=true;
 view.ScrollBars:=ssBoth;
 view.WordWrap:=false;
 view.OnKeyPress:=InputKey;

 sheet.PageControl:=Book;
 Book.ActivePage:=sheet;
 bas:=TBasicThread.Create('');
 bas.FreeOnTerminate:=true;
 bas.OnTerminate:=BasTerminated;
 bas.Tag:=integer(view);
 bas.OnSendKey:=OutputKey;
 sheet.Tag:=integer(bas);

 bas.Resume;

 ActiveControl:=view;
end;

procedure TMainForm.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (Key=VK_F1) and (Shift=[ssCtrl,ssAlt]) then begin
  Key:=0;
  NewMachine
 end
end;

end.
